#ifndef POC2DMODULAR_BASIC_DATA_HPP
#define POC2DMODULAR_BASIC_DATA_HPP


#include <string>
#include <utility>

namespace data {
    class BasicData {
    public:

        const std::string name{ "Basic" };

        BasicData() = delete;

        explicit BasicData(std::string name) : name(std::move(name)) {}

        virtual ~BasicData() noexcept = default;

        virtual void key_callback(int key, int scancode, int action, int mods) = 0;

        virtual void cursor_position_callback(double xpos, double ypos) = 0;

        virtual void scroll_callback(double xoffset, double yoffset) = 0;

        virtual void window_pos(int xpos, int ypos) = 0;

        virtual void window_size(int width, int height) = 0;
    };
}


#endif //POC2DMODULAR_BASIC_DATA_HPP
